function [m] = bt1xx(musArr44100)
    
    fs = 44100;
    
    L = length(musArr44100);
    
    dd = 1000;
    
    z = zeros(dd+1,1);
    
    y = abs([z ; musArr44100]);
    [m,d] = lowpass(y, 4, fs, "ImpulseResponse", "iir", "Steepness",0.5);
    [m,d] = bandpass(y, [1 5], fs, "ImpulseResponse", "iir", "Steepness",0.5);
    
end

% ydec = decimate(y, 64);
% 
% [m,d] = lowpass(ydec, 4, fs/64, "ImpulseResponse", "iir", "Steepness",0.5);
% [m,d] = bandpass(y, [1 5], fs/64, "ImpulseResponse", "iir", "Steepness",[0.5 0.5]);
% 
% 
% 





% fs = 44100;
% 
% [musArr44100, ~] = audioread(['work/etyp1/mus.wav']);
% yOrg = (musArr44100(6*44100:11*44100, 1) + musArr44100(6*44100:11*44100, 2))/2;
% sound(yOrg, fs);
% 
% [musArr44100, ~] = audioread(['work/etyp1/mus.wav']);
% yOrg = (musArr44100(6*44100:11*44100, 1) + musArr44100(6*44100:11*44100, 2))/2;
% sound(yOrg, fs);
% 
% [musArr44100, ~] = audioread(['work/sambaOrg1/mus.wav']);
% yOrg = (musArr44100(8*44100:14*44100, 1) + musArr44100(8*44100:14*44100, 2))/2;
% sound(yOrg, fs);
% 
% [musArr44100, ~] = audioread(['work/pump1/mus.wav']);
% yOrg = (musArr44100(8*44100:14*44100, 1) + musArr44100(8*44100:14*44100, 2))/2;
% sound(yOrg, fs);
% 
% % Dec og bp filter
% fig1;plott(1:length(yOrg), yOrg/max(yOrg));axis tight;
% D = 200;
% ydec = decimate(abs(yOrg), D);
% fig2;plott(1:length(ydec), ydec/max(ydec));axis tight;
% [m,d] = bandpass(ydec, [2 6], fs/D, "ImpulseResponse", "iir", "Steepness",[0.7 0.7], 'StopbandAttenuation',30);
% fig3;plott(1:length(m), m/max(m));axis tight;
% 
% % glidende filt uten dec
% L = length(yOrg);
% dd = 1000;
% z = zeros(dd+1,1);
% y = abs([z ; yOrg]);
% m = zeros(size(y));
% for s = dd+1 : size(y,1)
%     diffSum = 0;
%     for d = 1 : dd
%         %v = sin((pi/2)*d/dd);
%         v = 1;
%         diffSum = diffSum + (y(s-d));
%     end
%     m(s) = diffSum;
% end
% fig3;plott(1:length(m), m/max(m));axis tight;
% 
% % manual dec
% L = length(yOrg);
% dd = 64*12; % 60hz
% z = zeros(dd+1,1);
% y = abs([z ; yOrg]);
% m = [];
% for s = dd+1 : dd : size(y,1)
%     diffSum = 0;
%     for d = 1 : dd
%         diffSum = diffSum + (y(s-d));
%     end
%     m = [m ; diffSum];
% end
% fig4;plott(1:length(m), m/max(m));axis tight;

%%%%%%%%%%%%
%{

|                     |                     |
[  uttafor    ][ inni ]...]
                      [  uttafor    ][ inni ]...]

pre: gain
para: T, ph, thr
fit:
    antTomme        telle restart uten treff                   --- senke thr
    antUttafor      telle i "uttafor" men tillate noen         --- øke tersk
    antGodTreff     vektet treff                               --- just ph T
    gjevnT          varians på T som lagres
 

%}



function [] = tt()

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% stream
fs = 44100;
[mus, ~] = audioread(['work/etyp1/mus.wav']);
% yOrg = (mus(6*44100:11*fs, 1) + mus(6*44100:11*fs, 2))/2;
yOrg = (mus(16*44100:35*fs, 1) + mus(16*44100:35*fs, 2))/2;
fig1;plott(1:length(yOrg), yOrg);axis tight;
%sound(yOrg, fs);
L = length(yOrg);

fsD = fs/(64*12); % ca 57 Hz

minTms = 200;
minTs = fsD * minTms / 1000;
maxTms = 600;
maxTs = fsD * maxTms / 1000;
th = 110;
chNr = 0;
sumY = 0;
m = [];
clickArr = []; % fsD
sTeller = 0;
funnetTsArr = [];
funnetTsArrAvr = 0;
oscFase = 0;      % Fs/64 sampl
oscFreq = 1/(12*25);   % Fs/64 sampl
oscS64teller = 0; % Fs/64 sampl
oscArr = [];      % Fs/64
for chNr_ = 1 : floor(L/64) - 1
    yCh = yOrg(chNr_*64 : chNr_*64 + 63);
    
    %%%% Inn til Mxj
    
    % Osc
    oscS64teller = oscS64teller + 1;
    oscY = sin(2*pi * oscFreq * oscS64teller + oscFase);
    oscYd = cos(2*pi * oscFreq * oscS64teller + oscFase);
    oscArr = [oscArr ; oscY];
    
    chNr = chNr + 1;
    for i = 1 : 64
        sumY = sumY + abs(yCh(i)); % første av 12 stk 64 summer
    end
    
    %%
    if chNr > 11 %%%%% Nedsampler her - er nå decimert
        
        m = [m ; sumY];
        
        if sumY > 100 && sTeller > minTs % Treff innafor grenser
            clickArr = [clickArr ; 1];
            
            if sTeller < maxTs % er over start transient
                funnetTsArr = [funnetTsArr ; sTeller];
                funnetTsArrAvr = mean(funnetTsArr);
            end
            sTeller = 0;  % resetter siden funnet edge
        else              % Ikke treff ennå
            clickArr = [clickArr ; 0];
        end
        
        % Osc
        if clickArr(end) == 1
            oscTs = 1/oscFreq;
            (oscTs/12 - funnetTsArrAvr)
            oscTs = oscTs - 0.2*(oscTs/12 - funnetTsArrAvr); 
            oscFreq = 1/oscTs;
            
            oscFase = oscFase + 0.4*oscYd;
        end
        
        %%%%%
        
        sTeller = sTeller + 1;
        
        sumY = 0; % summer/vinduer over 64*12 sampler
        chNr = 0; % dec 
    end
end
fig2;plott(1:length(m), m);line([1 length(m)], [th th]);axis tight;
fig3;plott(1:length(clickArr), clickArr, 'lCol',[0 0.5 1]);axis tight;
plott([1:length(oscArr)]*(1/12), oscArr, 'hold');axis tight;

floor(1000*funnetTsArr(2:end)/fsD)





end















