function [m] = bt1(musArr44100)
    
    L = length(musArr44100);
    
    dd = 1000;
    
    z = zeros(dd+1,1);
    
    y = [musArr44100 ; z];
    
    y0 = y(1:end - dd + 0);
    
    % Delay varsjoner av y0
    D = zeros(size(y0,1), dd);
    for i = 1 : dd
        yd = y(i + 1:end - dd + i);
        D(:, i) = y0 - yd;
    end
    
    m = zeros(size(y0));
    for s = 1 : size(y0,1)
        diffSum = 0;
        for d = 1 : dd
            % v = cos((pi/2)*d/dd);
            diffSum = diffSum + abs(y0(s) - D(s, d));
        end
        m(s) = diffSum;
    end
    
end

%{

mus = (A.musArr44100(6*44100:11*44100, 1) + A.musArr44100(6*44100:11*44100, 2))/2;
fig1;plott(1:length(mus), mus);
[m] = bt1(mus);
fig2;plott(1:length(m), m);





    m = zeros(size(y0));
    for s = 1 : size(y0,1)
        diffSum = 0;
        for d = 2 : dd
            %v = cos((pi/2)*d/dd);
            % diffSum = diffSum + abs(y0(s) - D(s, d));
            diffSum = diffSum + D(s, d);
        end
        diffSum = abs(y0(s)-diffSum);
        m(s) = diffSum;
    end

%}